#include "testlib.h"
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

struct Test {
    int n, m;
    vector <pair <int, int> > edges;

    void print() {
        printf("%d %d\n", n, m);
        for (int i = 0; i < m; i++) {
            printf("%d %d\n", edges[i].fs, edges[i].sc);
        }
    }
};

int main(int argc, char ** argv) {
    registerGen(argc, argv, 1);    

    if (argc != 2) {
        cerr << "Usage: n" << endl;

        return 1;
    }

    int n = atoi(argv[1]);

    int mid = n / 2;
    int mid2 = 3 * n / 4;

    Test test;
    test.n = n;
    for (int i = 1; i <= mid; i++) {
        test.edges.pb(mp(i, i + 1));
    }
    for (int i = mid + 1; i < n; i++) {
        test.edges.pb(mp(i + 1, i));
    }
    for (int i = 2; i <= mid; i += 2) {
        test.edges.pb(mp(i, mid + i / 2));
    }
    for (int i = mid2 + 2; i < n; i++) {
        test.edges.pb(mp(i, mid2));
    }
    test.m = (int) test.edges.size();

    test.print();
    
    return 0;
}
