#include "testlib.h"
#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

struct Test {
    int n, m;
    vector <pair <int, int> > edges;

    void print() {
        printf("%d %d\n", n, m);
        for (int i = 0; i < m; i++) {
            printf("%d %d\n", edges[i].fs, edges[i].sc);
        }
    }
};

int main(int argc, char ** argv) {
    registerGen(argc, argv, 1);    

    if (argc != 4) {
        cerr << "Usage: a, b, c" << endl;

        return 1;
    }

    int a = atoi(argv[1]);
    int b = atoi(argv[2]);
    int c = atoi(argv[3]);
    
    Test test;
    test.n = a + b + c + 1;
    test.m = a + b + c;
    for (int i = 1; i <= a; i++) {
        test.edges.pb(mp(i + 1, i));
    }
    for (int i = a + 1; i <= a + b; i++) {
        test.edges.pb(mp(i, i + 1));
    }
    for (int i = a + b + 1; i <= a + b + c; i++) {
        test.edges.pb(mp(i + 1, i));
    }

    test.print();
    
    return 0;
}
