#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

int nextV = 1;

int getV() {
    return nextV++;
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    int levels = atoi(argv[1]);
    int paths = atoi(argv[2]);
    int len = atoi(argv[3]);

    vector<pair<int, int> > edges;

    vector<int> ends;

    int n = (levels + 1) + levels * paths * (len - 1);

    for (int i = 1; i <= levels; i++) {
        ends.push_back(getV());
    }
    ends.push_back(n);
    for (int i = 0; i < levels; i++) {
        for (int j = 0; j < paths; j++) {
            int v = ends[i];
            for (int k = 0; k < len - 1; k++) {
                int vv = getV();
                edges.emplace_back(v, vv);
                v = vv;
            }
            edges.emplace_back(v, ends[i + 1]);
        }
    }

    assert(nextV <= n);

    cout << n << " " << edges.size() << "\n";
    for (auto [u, v] : edges) {
        if (rnd.next(0, 1)) {
            swap(u, v);
        }
        cout << u << " " << v << "\n";
    }
    return 0;
}

