#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <deque>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const int MX = 3 * 1000 * 1000;

int tc;
int n, m;
int u[MX], v[MX], d[MX];
vector <pair <int, int> > vertex[MX];
bool inq[MX];

void bfs(int v) {
    for (int i = 0; i < 3 * n; i++) {
        d[i] = -1;
        inq[i] = false;
    }
    d[v] = 0;
    queue <int> q;
    q.push(v);
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        for (auto& w : vertex[u]) {
            if (d[w.fs] == -1 || d[w.fs] > d[u] + w.sc) {
                d[w.fs] = d[u] + w.sc;
                if (!inq[w.fs])
                    q.push(w.fs);
            }
        }
    }
}

int main () {
    tc = 1;
    
    for (int tnum = 0; tnum < tc; tnum++) {
        scanf("%d%d", &n, &m);
        for (int i = 0; i < m; i++) {
            scanf("%d%d", &u[i], &v[i]);
            u[i]--, v[i]--;
        }
        for (int i = 0; i < 3 * n; i++)
            vertex[i].clear();
        for (int i = 0; i < m; i++) {
            vertex[v[i]].pb(mp(u[i], 1));
            vertex[u[i]].pb(mp(v[i], 1));       
        }
        for (int i = 0; i < n; i++)
            vertex[i].pb(mp(i + n, 0));
        for (int i = 0; i < m; i++) {
            vertex[u[i] + n].pb(mp(v[i] + n, 0));
        }
        for (int i = 0; i < n; i++)
            vertex[i + n].pb(mp(i + 2 * n, 0));
        for (int i = 0; i < m; i++) {
            vertex[v[i] + 2 * n].pb(mp(u[i] + 2 * n, 1));
            vertex[u[i] + 2 * n].pb(mp(v[i] + 2 * n, 1));
        }
        bfs(0);

        printf("%d\n", d[3 * n - 1]);
    }

    return 0;
}
