#include "testlib.h"
#include <bits/stdc++.h>

//                      0    1    2                   3                   4   
constexpr int MAXC[] = {100, 100, 1000 * 1000 * 1000, 1000 * 1000 * 1000, 1000 * 1000 * 1000};
constexpr int MAXN[] = {100, 100, 100,                1000,               200 * 1000};

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int group = 4;
    if (validator.group() != "")
        group = atoi(validator.group().c_str());

    int n = inf.readInt(1, MAXN[group], "n");
    inf.readSpace();
    int T = inf.readInt(1, MAXC[group], "T");
    inf.readEoln();

    for (int i = 0; i < n; i++) {
        int l = inf.readInt(0, MAXC[group], "l[" + vtos(i) + "]");
        inf.readSpace();
        int r = inf.readInt(0, MAXC[group], "r[" + vtos(i) + "]");
        inf.readEoln();

        ensuref(l < r, "Starting time should be less than ending time");
    }

    inf.readEof();
    return 0;
}

