#include "testlib.h"
#include <bits/stdc++.h>

constexpr int MAXC = 1000 * 1000;
//                      0   1   2    3     4   
constexpr int MAXN[] = {10, 10, 100, 10000, 50 * 1000};

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int group = (validator.group() == "" ? 4 : atoi(validator.group().c_str()));

    int n = inf.readInt(2, MAXN[group], "n");
    inf.readSpace();
    int k = inf.readInt(1, n / 2, "k");
    inf.readEoln();

    std::set<std::pair<int, int> > points;
    for (int i = 0; i < n; i++) {
        int x = inf.readInt(-MAXC, MAXC, "x[" + vtos(i) + "]");
        inf.readSpace();
        int y = inf.readInt(-MAXC, MAXC, "y[" + vtos(i) + "]");
        inf.readEoln();

        ensuref(!points.count(std::make_pair(x, y)), "All points must be distinct");
        points.emplace(x, y);
    }

    inf.readEof();
    return 0;
}

