#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const int MX = 50 * 1000;
int x[MX], y[MX], xs[MX], ys[MX];
int n, k;
int tc;
int cnt[MX];
int pcnt[MX], scnt[MX];
int a[MX], b[MX];
int psuma[MX], psumb[MX], ssuma[MX], ssumb[MX];

int get(int l, int r) {
    for (int i = 0; i < n; i++) {
        a[i] = b[i] = 0;
    }    
    for (int i = 0; i < n; i++) {
        if (x[i] <= l) {
            a[y[i]]++;
        }
        if (x[i] >= r) {
            b[y[i]]++;
        }
    }
    psuma[0] = a[0];
    psumb[0] = b[0];
    for (int i = 1; i < n; i++) {
        psuma[i] = psuma[i - 1] + a[i];
        psumb[i] = psumb[i - 1] + b[i]; 
    }
    ssuma[n - 1] = a[n - 1];
    ssumb[n - 1] = b[n - 1];
    for (int i = n - 2; i >= 0; i--) {
        ssuma[i] = ssuma[i + 1] + a[i];
        ssumb[i] = ssumb[i + 1] + b[i];
    }
    int lb = 0, rb = 1, best = 0;
    while (lb < n && rb < n) {
        rb = max(rb, lb);
        if (min(psuma[lb], ssumb[rb]) + min(psumb[lb], ssuma[rb]) >= k) {
            best = max(best, ys[rb] - ys[lb]);
            rb++;
        } else {
            lb++;
        }
    }

    return best;
}

int main () {
    tc = 1;
    for (int tnum = 0; tnum < tc; tnum++) {
        scanf("%d%d", &n, &k);
        for (int i = 0; i < n; i++) {
            scanf("%d%d", &x[i], &y[i]);
            xs[i] = x[i];
            ys[i] = y[i];
        }

        sort(xs, xs + n);
        sort(ys, ys + n);
        for (int i = 0; i < n; i++) {
            x[i] = lower_bound(xs, xs + n, x[i]) - xs;
            y[i] = lower_bound(ys, ys + n, y[i]) - ys;
            cnt[x[i]]++;
        }

        pcnt[0] = cnt[0];
        for (int i = 1; i < n; i++)
            pcnt[i] = pcnt[i - 1] + cnt[i];
        scnt[n - 1] = cnt[n - 1];
        for (int i = n - 2; i >= 0; i--)
            scnt[i] = scnt[i + 1] + cnt[i];

        int ans = 0;
        int l = 0, r = 0;
        while (pcnt[l] < k)
            l++;
        r = l;
        while (l < n && r < n && scnt[max(l, r)] >= k) {
            r = max(l, r);
            int w = xs[r] - xs[l];
            int h = get(l, r);
            ans = max(ans, min(w, h));
            if (w < h) {
                r++;
            } else {
                l++;
            }
        }

        printf("%d\n", ans);
    }

    return 0;
}
