#ifndef BZ
#pragma GCC optimize "-O3"
#endif
#include <bits/stdc++.h>

#define FASTIO
#define ALL(v) (v).begin(), (v).end()
#define rep(i, l, r) for (int i = (l); i < (r); ++i)

#ifdef FASTIO
#define scanf abacaba
#define printf abacaba
#endif

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

using namespace std;

const int MX = 1000 * 1000 + 7;

string ans[MX];

int main() {
#ifdef FASTIO
    ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0);
#endif
    int n, p, c;
    cin >> n >> p >> c;
    vector<pair<int, int> > a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first;
        a[i].second = i + 1;
    }
    sort(a.rbegin(), a.rend());
    int need = a[p - 1].first;
    reverse(a.begin(), a.end());
    int ptr = 0;
    for (int i = 0; i < n; i++) {
        while (ptr < i && a[ptr].first + c <= a[i].first) {
            ptr++;
        }
        int more = (n - i - 1) + (i - ptr);
        if (more < p) {
            ans[a[i].second] = "Pass";
        } else if (a[i].first + c >= need) {
            ans[a[i].second] = "Short";
        } else {
            ans[a[i].second] = "Fail";
        }
    }

    for (int i = 1; i <= n; i++) {
        cout << ans[i] << "\n";
    }
    return 0;
}

