#include <cstdio>
#include <cstdlib>
#include <iostream>
#include <algorithm>
#include <cstring>
#include <string>
#include <cmath>
#include <cassert>
#include <ctime>
#include <vector>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <deque>

using namespace std;

#define pb push_back
#define mp make_pair
#define fs first
#define sc second

const int MX = 1000 * 1000;

int tc;
int n, m;
int u[MX], v[MX], d[MX];
vector <pair <int, int> > vertex[MX];

void bfs(int v) {
    for (int i = 0; i < n; i++)
        d[i] = -1;
    d[v] = 0;
    deque <int> q;
    q.push_back(v);
    while (!q.empty()) {
        int u = q.front();
        q.pop_front();
        for (auto& w : vertex[u]) {
            if (d[w.fs] == -1 || d[w.fs] > d[u] + w.sc) {
                d[w.fs] = d[u] + w.sc;
                if (w.sc == 1)
                    q.push_back(w.fs);
                else
                    q.push_front(w.fs);
            }
        }
    }
}

int main () {
    tc = 1;
    
    for (int tnum = 0; tnum < tc; tnum++) {
        scanf("%d%d", &n, &m);
        for (int i = 0; i < m; i++) {
            scanf("%d%d", &u[i], &v[i]);
            u[i]--, v[i]--;
        }
        for (int i = 0; i < n; i++)
            vertex[i].clear();
        for (int i = 0; i < m; i++) {
            vertex[u[i]].pb(mp(v[i], 0));
            vertex[v[i]].pb(mp(u[i], 1));        
        }
        bfs(0);

        printf("%d\n", (d[n - 1] == n + 1 ? -1 : d[n - 1]));
    }

    return 0;
}
