#include <iostream>
#include <tuple>
#include <sstream>
#include <vector>
#include <cmath>
#include <ctime>
#include <bitset>
#include <cassert>
#include <cstdio>
#include <queue>
#include <set>
#include <map>
#include <fstream>
#include <cstdlib>
#include <string>
#include <cstring>
#include <algorithm>
#include <numeric>

#define mp make_pair
#define mt make_tuple
#define fi first
#define se second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for (int i = (int)(n) - 1; i >= 0; --i)
#define fore(i, a, b) for (int i = (int)(a); i <= (int)(b); ++i)

using namespace std;

typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<pii> vpi;
typedef vector<vi> vvi;
typedef long long i64;
typedef vector<i64> vi64;
typedef vector<vi64> vvi64;
typedef pair<i64, i64> pi64;
typedef double ld;

template<class T> bool uin(T &a, T b) { return a > b ? (a = b, true) : false; }
template<class T> bool uax(T &a, T b) { return a < b ? (a = b, true) : false; }

int cnt[4];
vi xs;
int l, r;

void change(int x, int s, int d) {
    if (x > xs[l] && x < xs[r]) return;
    cnt[int(x <= xs[l])] += d;
    cnt[2 + s] += d;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(10);
    cout << fixed;
#ifdef LOCAL_DEFINE
    freopen("input.txt", "rt", stdin);
#endif

    int T;
    T = 1;
    while (T--) {
        int n, k;
        cin >> n >> k;
        vector<pii> p(n);
        xs.clear();
        forn(i, n) cin >> p[i].fi >> p[i].se, xs.pb(p[i].fi);
        sort(all(xs));
        sort(all(p), [](pii a, pii b){return mp(a.se, a.fi) < mp(b.se, b.fi);});
        l = r = 0;
        int ans = 0;
        while (l < n) {
            uax(r, l);
            while (r < n) {
                forn(i, 4) cnt[i] = 0;
                forn(i, n) change(p[i].fi, 1, 1);
                int res = 0;
                int ry = 0;
                forn(ly, n) {
                    change(p[ly].fi, 0, 1);
                    while (ry < ly) change(p[ry++].fi, 1, -1);
                    if (cnt[2] >= k) {
                        while (*min_element(cnt, cnt + 4) >= k) {
                            assert(ry < n);
                            uax(res, p[ry].se - p[ly].se);
                            change(p[ry++].fi, 1, -1);
                        }
                    }
                }

//                cerr << l << ' ' << r << ' ' << res << '\n';
                uax(ans, min(res, xs[r] - xs[l]));
                if (res > xs[r] - xs[l]) ++r;
                else break;
            }
            ++l;
        }
        cout << ans << '\n';
    }

#ifdef LOCAL_DEFINE
    cerr << "Time elapsed: " << 1.0 * clock() / CLOCKS_PER_SEC << " s.\n";
#endif
    return 0;
}
