#include <iostream>
#include <tuple>
#include <sstream>
#include <vector>
#include <cmath>
#include <ctime>
#include <bitset>
#include <cassert>
#include <cstdio>
#include <queue>
#include <set>
#include <map>
#include <fstream>
#include <cstdlib>
#include <string>
#include <cstring>
#include <algorithm>
#include <numeric>

#define mp make_pair
#define mt make_tuple
#define fi first
#define se second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define for1(i, n) for (int i = 1; i <= (int)(n); ++i)
#define ford(i, n) for (int i = (int)(n) - 1; i >= 0; --i)
#define fore(i, a, b) for (int i = (int)(a); i <= (int)(b); ++i)

using namespace std;

typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<pii> vpi;
typedef vector<vi> vvi;
typedef long long i64;
typedef vector<i64> vi64;
typedef vector<vi64> vvi64;
typedef pair<i64, i64> pi64;
typedef double ld;

template<class T> bool uin(T &a, T b) { return a > b ? (a = b, true) : false; }
template<class T> bool uax(T &a, T b) { return a < b ? (a = b, true) : false; }

const int maxn = 110000;
int n, k;
int x[maxn], y[maxn];

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(10);
    cout << fixed;
#ifdef LOCAL_DEFINE
    freopen("input.txt", "rt", stdin);
#endif

    int T;
    T = 1;
    while (T--) {
        cin >> n >> k;
        forn(i, n) cin >> x[i] >> y[i];
        int L = 0, R = 2e9 + 1;
        int bx, by;
        while (R - L > 1) {
            int M = (L + R) / 2;
            bool ok = false;
            forn(i, n) forn(j, n) {
                int X = x[i], Y = y[j];
                int cnt[4] = {};
                forn(k, n) {
                    if (x[k] > X && x[k] < X + M) continue;
                    if (y[k] > Y && y[k] < Y + M) continue;
                    if (x[k] <= X) ++cnt[0];
                    else ++cnt[1];
                    if (y[k] <= Y) ++cnt[2];
                    else ++cnt[3];
                }
                if (*min_element(cnt, cnt + 4) >= k) {
                    ok = true;
                    bx = X, by = Y;
                }
            }
            (ok ? L : R) = M;
        }
        cout << L << '\n';
        cerr << bx << ' ' << by << '\n';
    }

#ifdef LOCAL_DEFINE
    cerr << "Time elapsed: " << 1.0 * clock() / CLOCKS_PER_SEC << " s.\n";
#endif
    return 0;
}
