// 2018, Sayutin Dmitry.

#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;

using std::vector;
using std::map;
using std::array;
using std::set;
using std::string;

using std::pair;
using std::make_pair;

using std::tuple;
using std::make_tuple;
using std::get;

using std::min;
using std::abs;
using std::max;
using std::swap;

using std::unique;
using std::sort;
using std::generate;
using std::reverse;
using std::min_element;
using std::max_element;

#ifdef LOCAL
#define LASSERT(X) assert(X)
#else
#define LASSERT(X) {}
#endif

template <typename T>
T input() {
    T res;
    cin >> res;
    LASSERT(cin);
    return res;
}

template <typename IT>
void input_seq(IT b, IT e) {
    std::generate(b, e, input<typename std::remove_reference<decltype(*b)>::type>);
}

#define SZ(vec)         int((vec).size())
#define ALL(data)       data.begin(),data.end()
#define RALL(data)      data.rbegin(),data.rend()
#define TYPEMAX(type)   std::numeric_limits<type>::max()
#define TYPEMIN(type)   std::numeric_limits<type>::min()

int main() {
    std::iostream::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    // code here
    int n = input<int>();
    int p = input<int>();
    int c = input<int>();
    
    vector<int> a(n);
    input_seq(ALL(a));

    auto b = a;
    sort(ALL(b), std::greater<int>());

    for (int elem: a) {
        int bestrk = std::lower_bound(ALL(b), elem + c, std::greater<int>()) - b.begin();
        int worstrk = std::lower_bound(ALL(b), elem - c, std::greater<int>()) - b.begin() - 1;

        if (bestrk >= p)
            cout << "Fail\n";
        else if (worstrk < p)
            cout << "Pass\n";
        else
            cout << "Short\n";
    }
    
    return 0;
}
