#ifndef BZ
#pragma GCC optimize "-O3"
#endif
#include <bits/stdc++.h>

#define FASTIO
#define ALL(v) (v).begin(), (v).end()
#define rep(i, l, r) for (int i = (l); i < (r); ++i)

#ifdef FASTIO
#define scanf abacaba
#define printf abacaba
#endif

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

using namespace std;

bool check(vector<pair<int, int> > a, int p, int id) {
    sort(a.rbegin(), a.rend());
    int need = a[p - 1].first;
    for (int i = 0; i < int(a.size()); i++) {
        if (a[i].second == id) {
            return a[i].first >= need;
        }
    }
    assert(false);
}

bool checkCan(vector<pair<int, int> > a, int p, int c, int id) {
    for (int i = 0; i < int(a.size()); i++) {
        if (a[i].second == id) {
            a[i].first += c;
        }
    }
    return check(a, p, id);
}

bool checkAny(vector<pair<int, int> > a, int p, int c, int id) {
    for (int i = 0; i < int(a.size()); i++) {
        if (a[i].second != id) {
            a[i].first += c;
        }
    }
    return check(a, p, id);
}

int main() {
#ifdef FASTIO
    ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0);
#endif
    int n, p, c;
    cin >> n >> p >> c;
    vector<pair<int, int> > a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first;
        a[i].second = i + 1;
    }

    for (int i = 1; i <= n; i++) {
        if (checkAny(a, p, c, i)) {
            cout << "Pass\n";
        } else if (checkCan(a, p, c, i)) {
            cout << "Short\n";
        } else {
            cout << "Fail\n";
        }
    }
    return 0;
}

